#!/usr/local/bin/perl -w


print '\documentclass{article}
\usepackage{pst-all}
\newcommand{\hlnode}[2]{\rnode{n#1}{\psframebox{#2}}}
\newcommand{\coeffnode}[1]{\rnode{c#1}{\psframebox{#1}}}
\newcommand{\rnext}[2]{\nccurve[angleA=-120,angleB=-60,ncurv=.5]{->}{n#1}{n#2}}
\newcommand{\rprev}[2]{\nccurve[angleA=120,angleB=60,ncurv=.5]{->}{n#1}{n#2}}
\newcommand{\cnext}[2]{\nccurve[angleB=-45,angleA=90,linestyle=dotted]{->}{n#1}{n#2}}
\newcommand{\chead}[2]{\nccurve[angleA=90,linestyle=dotted,angleB=-90]{->}{c#1}{n#2}}

\begin{document}
\begin{psmatrix}
\begin{psmatrix}
';

undef(%found);

$first=<>;
chomp($first);
@coeffs=split(/\s+/,$first);

while(<>){
    chomp();
    @cells=split(/\s+/);
    undef(@line1);
    undef(@line2);
    foreach $cell (@cells){
	($cell,$bindex,$rnext,$rprev,$cnext)=split(",",$cell);
	$found{abs($bindex)}=1;
	push(@line1,"\\hlnode{$cell}{$bindex}");
	push(@line2,"\\rnext{$cell}{$rnext}");
	push(@line2,"\\rprev{$cell}{$rprev}");
	push(@line3,"\\cnext{$cell}{$cnext}") if ($cnext!=-1);
    }
    print join("&",@line1),"\\\\\n";
    print join(" ",@line2),"\n";
}
print join("\n",@line3),"\n";
print '\end{psmatrix}
\\\\\begin{psmatrix}[colsep=0pt]
';

undef(@line1);
undef(@line2);
foreach $coeff (@coeffs){
    ($c,$p)=split(",",$coeff);
    push(@line1,"\\coeffnode{$c}");
    push(@line2,"\\chead{$c}{$p}");
}

print join("&",@line1),"\\\\\n";
print join(" ",@line2),"\n";

print '\end{psmatrix}\end{psmatrix}
\end{document}
';

