#ifndef _OMS_H
#define _OMS_H
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef USE_ZRAM
#include <z_bt.h>
#include <z_par.h>
#include <z_time.h>
#include <z_io.h>
#include <z_signal.h>
 z_bt_ProcSetT oms_procset;
#define oms_myproc z_myproc
#define oms_numprocs z_numprocs
#define MAIN mmain
#else
#define oms_myproc 0
#define oms_myprocs 0
#define MAIN main
#endif

#define GLOBAL_NAME_FORMAT "%s-globals"

#include "nalloc.h"
#include "statearray.h"
#include "nodedef.h"
#include "globaldef.h"

#include "nu_sign.h"

typedef na_node_p search_state;
typedef sarray_p sign_array;






#ifdef USE_ZRAM
#define ZRAM_ARGS_PROTO z_bt_DoProc whatToDo, void *ref
#define ZRAM_ARGS whatToDo,ref
#else
#define ZRAM_ARGS_PROTO void * whatToDo, void *ref
#define ZRAM_ARGS 0,0
#define whatToDo(state,dummy) oms_BranchInPlace(global,state,0,0)
#define z_NewNode(dummy,size) malloc(size)
typedef na_node_p z_NodeP;
#endif



#ifndef _MAKING_PROTOS
bool oms_BranchInPlace(na_node_p global, na_node_p state, ZRAM_ARGS_PROTO);
bool oms_real_BranchInPlace(na_node_p global, na_node_p state, ZRAM_ARGS_PROTO);
search_state TrySetting(na_node_p state, na_node_p global, array_index_t basis, nu_sign_t sign, ZRAM_ARGS_PROTO);
bool SetAndConsequences(na_node_p state, na_node_p global, array_index_t basis, nu_sign_t sigma);
bool nuoms_read_boundary_hook(na_node_p global, na_node_p local, int b, int sigma);
static na_node_p nuoms_alloc_local(na_node_p global, na_node_p local);
void SaveState(search_state state);
void RestoreState(search_state state);
array_index_t ChooseUnset(na_node_p,search_state);
search_state TrySetting(na_node_p state, na_node_p global, array_index_t basis, nu_sign_t sign,
		ZRAM_ARGS_PROTO);
#endif


#endif



